/////////////////////////////////////////////////////////////////////////////
// FormButton.cpp 
//
// Implementation file.

#include "stdafx.h"
#include "RtosCppDemo.h"
#include "FormButton.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CFormButton

CFormButton::CFormButton()
{
}

CFormButton::~CFormButton()
{
}


BEGIN_MESSAGE_MAP(CFormButton, CButton)
	//{{AFX_MSG_MAP(CFormButton)
	ON_WM_SETFOCUS()
	ON_WM_LBUTTONUP()
	ON_WM_KILLFOCUS()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CFormButton message handlers

void CFormButton::OnSetFocus(CWnd* pOldWnd) 
{
	if (pOldWnd) 
	{
		UINT bn_style = (UINT)GetWindowLong(pOldWnd->m_hWnd, GWL_STYLE) & 0xff;
		if (bn_style & BS_DEFPUSHBUTTON) 
		{
			pOldWnd->SendMessage (BM_SETSTYLE, 
				MAKELONG(0,bn_style & ~BS_DEFPUSHBUTTON),
				(LPARAM)MAKELONG(TRUE,0));
		}
	}

	CButton::OnSetFocus(pOldWnd);

	if (m_hWnd && GetParent())
		GetParent()->SendMessage(WM_ACTIVATE_CONTROL, 0, 0);
}

void CFormButton::OnLButtonUp(UINT nFlags, CPoint point)
{
	CButton::OnLButtonUp(nFlags, point);

	// Let ::IsDialogMessage handle the default button processing.
	CWnd* pParent = GetParent();
	MSG msg;
	msg.hwnd = pParent->m_hWnd;
	msg.message = WM_LBUTTONUP;
	msg.wParam = nFlags;
	msg.lParam = MAKELONG(point.x,point.y);
	msg.time = 0;
	msg.pt = point;
	pParent->PreTranslateMessage (&msg);
}

void CFormButton::OnKillFocus(CWnd* pNewWnd) 
{
	CButton::OnKillFocus(pNewWnd);

	CWnd* pParent = GetParent();
	if (pParent) 
	{
		pParent->SendMessage(DM_SETDEFID, 0L, 0L);
		CWnd* pWndFirst = pParent->GetNextDlgTabItem(NULL, FALSE);
		CWnd* pTemp = pWndFirst;

		do 
		{
			UINT bn_style = (UINT)GetWindowLong(pTemp->m_hWnd, GWL_STYLE) & 0xff;
			if (bn_style & BS_DEFPUSHBUTTON) 
			{
				pTemp->SendMessage (BM_SETSTYLE, 
					MAKELONG(0,bn_style & ~BS_DEFPUSHBUTTON), 
					(LPARAM)MAKELONG(TRUE,0));
			}
			pTemp = pParent->GetNextDlgTabItem(pTemp, FALSE);

		}while (pTemp != pWndFirst);
	}

	if (pNewWnd) 
	{
		UINT bn_style = (UINT)GetWindowLong(pNewWnd->m_hWnd, GWL_STYLE) & 0xff;
		if (bn_style & BS_DEFPUSHBUTTON) 
		{
			pNewWnd->SendMessage (BM_SETSTYLE, 
				MAKELONG(0,bn_style & BS_DEFPUSHBUTTON), 
				(LPARAM)MAKELONG(TRUE,0));
		}
	}
}

