// FormTabControl.cpp : implementation file
//

#include "stdafx.h"
#include "RtosCppDemo.h"
#include "FormTabControl.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CFormTabControl

CFormTabControl::CFormTabControl()
{
}

CFormTabControl::~CFormTabControl()
{
}


BEGIN_MESSAGE_MAP(CFormTabControl, CTabCtrl)
	//{{AFX_MSG_MAP(CFormTabControl)
	ON_WM_KILLFOCUS()
	ON_WM_SETFOCUS()
	ON_WM_LBUTTONUP()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CFormTabControl message handlers

void CFormTabControl::OnSetFocus(CWnd* pOldWnd) 
{
	if (pOldWnd) 
	{
		UINT bn_style = (UINT)GetWindowLong(pOldWnd->m_hWnd, GWL_STYLE) & 0xff;
		if (bn_style & BS_DEFPUSHBUTTON) 
		{
			pOldWnd->SendMessage (BM_SETSTYLE, 
				MAKELONG(0,bn_style & ~BS_DEFPUSHBUTTON),
				(LPARAM)MAKELONG(TRUE,0));
		}
	}

	CTabCtrl::OnSetFocus(pOldWnd);

	if (m_hWnd && GetParent())
		GetParent()->SendMessage(WM_ACTIVATE_CONTROL, 0, 0);
}

void CFormTabControl::OnLButtonUp(UINT nFlags, CPoint point)
{
	CTabCtrl::OnLButtonUp(nFlags, point);

	// Let ::IsDialogMessage handle the default button processing.
	CWnd* pParent = GetParent();
	MSG msg;
	msg.hwnd = pParent->m_hWnd;
	msg.message = WM_LBUTTONUP;
	msg.wParam = nFlags;
	msg.lParam = MAKELONG(point.x,point.y);
	msg.time = 0;
	msg.pt = point;
	pParent->PreTranslateMessage (&msg);
}

void CFormTabControl::OnKillFocus(CWnd* pNewWnd) 
{
	CTabCtrl::OnKillFocus(pNewWnd);

	CWnd* pParent = GetParent();
	if (pParent) 
	{
		pParent->SendMessage(DM_SETDEFID, 0L, 0L);
		CWnd* pWndFirst = pParent->GetNextDlgTabItem(NULL, FALSE);
		CWnd* pTemp = pWndFirst;

		do 
		{
			UINT bn_style = (UINT)GetWindowLong(pTemp->m_hWnd, GWL_STYLE) & 0xff;
			if (bn_style & BS_DEFPUSHBUTTON) 
			{
				pTemp->SendMessage (BM_SETSTYLE, 
					MAKELONG(0,bn_style & ~BS_DEFPUSHBUTTON), 
					(LPARAM)MAKELONG(TRUE,0));
			}
			pTemp = pParent->GetNextDlgTabItem(pTemp, FALSE);

		}while (pTemp != pWndFirst);
	}

	if (pNewWnd) 
	{
		UINT bn_style = (UINT)GetWindowLong(pNewWnd->m_hWnd, GWL_STYLE) & 0xff;
		if (bn_style & BS_DEFPUSHBUTTON) 
		{
			pNewWnd->SendMessage (BM_SETSTYLE, 
				MAKELONG(0,bn_style & BS_DEFPUSHBUTTON), 
				(LPARAM)MAKELONG(TRUE,0));
		}
	}
}

