/////////////////////////////////////////////////////////////////////////////
// RtosDemoCtl.h
//
// Declaration of the CRtosDemoCtrl ActiveX Control class.

#if !defined(AFX_RTOSDEMOCTL_H__04F4EFD4_F749_11D2_873B_444553540000__INCLUDED_)
#define AFX_RTOSDEMOCTL_H__04F4EFD4_F749_11D2_873B_444553540000__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

#include "nertos.h"
#include "Formctrl.h"
#include "FormButton.h"
#include "FormTabControl.h"
#include "FormEdit.h"
#include "DemoRtos.h"

/////////////////////////////////////////////////////////////////////////////
// CRtosDemoCtrl : See RtkDemoCtl.cpp for implementation.

class CRtosDemoCtrl : public CFormControl
{
	DECLARE_DYNCREATE(CRtosDemoCtrl)

// Constructor
public:
	CRtosDemoCtrl();

	//{{AFX_DATA(CRtosDemoCtrl)
	enum { IDD = IDD_FORM };
	CFormEdit	m_tasksEdit;
	CFormTabControl	m_tabControl;
	CFormButton	m_btnStop;
	CFormButton	m_btnStart;
	CFormButton	m_btnGo;
	CFormButton	m_btnBreak;
	CString	m_strStatus;
	CString	m_strTStatus;
	CString	m_strEmulator;
	CString	m_strMsg;
	//}}AFX_DATA

// Overrides
	virtual void OnInitialUpdate();
	virtual HRESULT OnActivateInPlace(BOOL bUIActivate, LPMSG pMsg);

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CRtosDemoCtrl)
	public:
	virtual void OnDraw(CDC* pdc, const CRect& rcBounds, const CRect& rcInvalid);
	virtual void DoPropExchange(CPropExchange* pPX);
	virtual void OnResetState();
	//}}AFX_VIRTUAL

// Implementation
protected:
	~CRtosDemoCtrl();

	void InitRTOS();
	void UpdateAll();
	void UpdateApp();
	bool UpdateTasks();
	bool UpdateTimers();
	bool UpdateSemaphores();
	CString GetStr16(int nameptr16);
	void Append(CEdit& rEdit, CString str);
	void SizeTabs();

	INertosEvents* m_pEvents;
	CEdit m_timersEdit;
	CEdit m_semaphoresEdit;

	bool		m_bRTOSInit;
	DWORD		m_nAppAddr;
	TApp16		m_App;
	TTask16		m_Task;
	TTimer16	m_Timer;
	TSema16		m_Sema;

	/* Supply ambient container properties to stop resize handles
	CAmbientDisp m_ambientDisp;
	*/

	virtual void DoDataExchange(CDataExchange* pDX);

	DECLARE_OLECREATE_EX(CRtosDemoCtrl)    // Class factory and guid
	DECLARE_OLETYPELIB(CRtosDemoCtrl)      // GetTypeInfo
	DECLARE_PROPPAGEIDS(CRtosDemoCtrl)     // Property page IDs
	DECLARE_OLECTLTYPE(CRtosDemoCtrl)		// Type name and misc status

// Message maps
	//{{AFX_MSG(CRtosDemoCtrl)
	afx_msg void OnGo();
	afx_msg void OnBreak();
	afx_msg void OnStart();
	afx_msg void OnStop();
	afx_msg void OnSelchangeTabcontrol(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnSize(UINT nType, int cx, int cy);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()

// Dispatch maps
	//{{AFX_DISPATCH(CRtosDemoCtrl)
		// NOTE - ClassWizard will add and remove member functions here.
		//    DO NOT EDIT what you see in these blocks of generated code !
	//}}AFX_DISPATCH
	DECLARE_DISPATCH_MAP()

	afx_msg void AboutBox();

// Event maps
	//{{AFX_EVENT(CRtosDemoCtrl)
		// NOTE - ClassWizard will add and remove member functions here.
		//    DO NOT EDIT what you see in these blocks of generated code !
	//}}AFX_EVENT
	DECLARE_EVENT_MAP()

// Interface map
	DECLARE_INTERFACE_MAP()

	BEGIN_INTERFACE_PART(NertosObj, INertos)
		STDMETHOD(ConnectEvents)(INertosEvents* ine);
		STDMETHOD(Endian)(short LEndian);
		STDMETHOD(ProgramLoaded)(void);
		STDMETHOD(ProgramReset)(void);
		STDMETHOD(ReadMemoryTest)(short memtype, long address, long size, long dest);
		STDMETHOD(Init)(BSTR initstring);
		STDMETHOD(Terminate)(void);
		STDMETHOD(Started)(void);
		STDMETHOD(Stopped)(long pc);
		STDMETHOD(AboutBox)(void);
		STDMETHOD(TraceStarted)(void);
		STDMETHOD(TraceStopped)(void);
	END_INTERFACE_PART(NertosObj)

// Dispatch and event IDs
public:
	enum {
	//{{AFX_DISP_ID(CRtosDemoCtrl)
		// NOTE: ClassWizard will add and remove enumeration elements here.
		//    DO NOT EDIT what you see in these blocks of generated code !
	//}}AFX_DISP_ID
	};
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Developer Studio will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_RTOSDEMOCTL_H__04F4EFD4_F749_11D2_873B_444553540000__INCLUDED)
